futhark-0.25.27: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Analysis.HORep.MapNest

# Documentation

data Nesting rep Source #

Constructors

Nesting |

Fields

- nestingParamNames :: [VName]
- nestingResult :: [VName]
- nestingReturnType :: [Type]
- nestingWidth :: SubExp

#### Instances

Instances details

Show (Nesting rep) Source # |
Instance details Defined in Futhark.Analysis.HORep.MapNest Methods showsPrec :: Int -> Nesting rep -> ShowS Source # show :: Nesting rep -> String Source # showList :: [Nesting rep] -> ShowS Source #
Eq (Nesting rep) Source # |
Instance details Defined in Futhark.Analysis.HORep.MapNest Methods (==) :: Nesting rep -> Nesting rep -> Bool Source # (/=) :: Nesting rep -> Nesting rep -> Bool Source #
Ord (Nesting rep) Source # |

Instance details

Defined in Futhark.Analysis.HORep.MapNest

Methods

compare :: Nesting rep -> Nesting rep -> Ordering Source #

(<) :: Nesting rep -> Nesting rep -> Bool Source #

(<=) :: Nesting rep -> Nesting rep -> Bool Source #

(>) :: Nesting rep -> Nesting rep -> Bool Source #

(>=) :: Nesting rep -> Nesting rep -> Bool Source #

max :: Nesting rep -> Nesting rep -> Nesting rep Source #

min :: Nesting rep -> Nesting rep -> Nesting rep Source #

data MapNest rep Source #

Constructors

MapNest SubExp (Lambda rep) [Nesting rep] [Input] |

#### Instances

Instances details

RepTypes rep => Show (MapNest rep) Source # |
Instance details Defined in Futhark.Analysis.HORep.MapNest Methods showsPrec :: Int -> MapNest rep -> ShowS Source # show :: MapNest rep -> String Source # showList :: [MapNest rep] -> ShowS Source #

typeOf :: MapNest rep -> [Type] Source #

params :: MapNest rep -> [VName] Source #

inputs :: MapNest rep -> [Input] Source #

setInputs :: [Input] -> MapNest rep -> MapNest rep Source #

fromSOAC :: (Buildable rep, MonadFreshNames m, LocalScope rep m, Op rep ~ SOAC rep) => SOAC rep -> m (Maybe (MapNest rep)) Source #

toSOAC :: (MonadFreshNames m, HasScope rep m, Buildable rep, BuilderOps rep, Op rep ~ SOAC rep) => MapNest rep -> m (SOAC rep) Source #